! In der Hauptstadt Olog von Landauland gibt es eine sehr lange Straße,
! die Blockstraße. Die Gebäude auf der linken Straßenseite sind durch
! Querstraßen in regelmäßige Blöcke geteilt (ähnlich wie in Manhattan), 
! auf der rechten Seite fließt parallel zur Straße der Datenstrom.
! In jedem Block gibt es Wohnhäuser, manche der Blöcke weisen aber 
! zusätzlich eine Schule, einen Supermarkt und/oder eine U-Bahnstation
! auf. 
! Das Immobilienunternehmen "Complex City" möchte einen der (nahezu baugleichen)
! Blöcke kaufen. Dabei soll derjenige Block gewählt werden, für den das
! Maximum m der Entfernungen zur nächsten Schule, zum nächsten Supermarkt und
! zur nächsten U-Bahnstation (jeweils in Blöcken gemessen) am geringsten ist.
! (Hat ein Block Schule, U-Bahn und Supermarkt, so ist m = 0. Hat der Block 
! nur einen Supermarkt und die nächste Schule ist 3, die nächste U-Bahnstation
! 2 Blöcke entfernt, dann ist m=3 usw... Falls mehrere Blöcke m minimieren, so
! ist ein beliebiger anzugeben.)
! Hilf Complex City!
! Vervollständige die untenstehende Funktion findBestBlock, welche als 
! einzige Eingabe ein logical Array der Form 3xn erhält, wobei n die Anzahl
! der Blöcke (= Länge der Straße) ist. Die obere Zeile stellt dar, welche 
! Blöcke eine Schule haben, die mittlere Zeile wo es Supermärkte gibt und 
! die untere Zeile wo es U-Bahnstationen gibt.
! Achte auf optimale Laufzeitkomplexität.

program main
    implicit none
    logical, dimension(1:3,1:10) :: blockstrasse
    blockstrasse(1,:) = [.true., .false., .false., .true., .false.,&
    &                   .false., .false., .true., .false., .false.]
    blockstrasse(2,:) = [.true., .false., .true., .false., .false.,&
    &                   .true., .false., .true., .true., .false.]
    blockstrasse(3,:) = [.false., .false., .true., .false., .false.,&
    &                   .false., .true., .false., .false., .true.]
    write(*,*) findBestBlock(blockstrasse)
contains
    integer function findBestBlock(blockstrasse)
        logical, dimension(:,:) :: blockstrasse
        ! ...
    end function

end program main